using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections;
using System.Text;
using System.IO;

public partial class _Default : System.Web.UI.Page
{
    //declaration for Total to be displayed in Footer.
    decimal Total;

    #region PageLoad
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            TempTable();
        }
    }
    #endregion

    #region DataSource with Sorting
    public void TempTable()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Id", typeof(int));
        dt.Columns.Add("Name", typeof(String));
        dt.Columns.Add("Email", typeof(String));
        dt.Columns.Add("Gender", typeof(String));
        dt.Columns.Add("Salary",typeof(int));
        dt.Columns.Add("Image", typeof(String));

        DataRow dr = dt.NewRow();
        dr["Id"] = 1;
        dr["Name"] = "Padmanabhan";
        dr["Email"] = "mail2padmanabhan@gmail.com";
        dr["Gender"] = "Male";
        dr["Salary"] = 10000;
        dr["Image"] = "232.jpg";
        dt.Rows.Add(dr);

        DataRow dr1 = dt.NewRow();
        dr1["Id"] = 2;
        dr1["Name"] = "Varatharaman";
        dr1["Email"] = "varatharaman@gmail.com";
        dr1["Gender"] = "Male";
        dr1["Salary"] = 20000;
        dr1["Image"] = "Photo-0009.jpg";
        dt.Rows.Add(dr1);

        DataRow dr2 = dt.NewRow();
        dr2["Id"] = 3;
        dr2["Name"] = "Sathya";
        dr2["Email"] = "sathay@gmail.com";
        dr2["Gender"] = "Male";
        dr2["Salary"] = 10500;
        dr2["Image"] = "DSC00010.JPG";
        dt.Rows.Add(dr2);

        Total = decimal.Parse(dt.Compute("sum(Salary)", "Salary>=0").ToString());
        Session["Salary"] = Total;

        Session["data"] = dt;
        Temp = dt.Copy();
         DataView dv = new DataView(dt);
         if (dv.Count != 0)
         {
             if (!this.SortField.Equals(String.Empty))
             {
                 string strDirect = String.Empty;
                 if (this.SortDirection.Equals("D"))
                     strDirect = " DESC";

                 dv.Sort = SortField + strDirect;
             }

             this.GridView2.DataSource = dv;
             this.GridView2.DataBind();
         }
         GridView1.DataSource = dt;
         GridView1.DataBind();

         GridView3.DataSource = dt;
         GridView3.DataBind();

         GridView4.DataSource = dt;
         GridView4.DataBind();

         GridView6.DataSource = dt;
         GridView6.DataBind();

     }
    #endregion

    #region GridView2 (BoundFields with Paging and Sorting)
     protected void GridView2_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        GridView2.PageIndex = e.NewPageIndex;
        TempTable();
    }
    protected void GridView2_Sorting(object sender, GridViewSortEventArgs e)
    {
        if (e.SortExpression.Trim() == this.SortField)
            this.SortDirection = (this.SortDirection == "D" ? "A" : "D");
        else
            this.SortDirection = "A";

        this.SortField = e.SortExpression;
        TempTable();
    }
     #endregion    

    #region GridView3 (Header,Footer, Insert, Update and Delete)

    protected void GridView3_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        int row = e.RowIndex;
        Temp.Rows[row].Delete();
        GridView3.DataSource = Temp;
        GridView3.DataBind();

    }
    protected void GridView3_RowUpdating(object sender, GridViewUpdateEventArgs e)
    {
        GridView3.EditIndex = e.RowIndex;
        GridView3.DataSource = Temp;
        GridView3.DataBind();
    }
    protected void GridView3_RowEditing(object sender, GridViewEditEventArgs e)
    {
        GridView3.EditIndex = e.NewEditIndex - 1;
        int row = e.NewEditIndex;
        Temp.Rows[row]["name"] = ((TextBox)GridView3.Rows[e.NewEditIndex].FindControl("txtname")).Text;
        Temp.Rows[row]["gender"] = ((DropDownList)GridView3.Rows[e.NewEditIndex].FindControl("ddlgender")).Text;
        Temp.Rows[row]["email"] = ((TextBox)GridView3.Rows[e.NewEditIndex].FindControl("txtemail")).Text;
        Temp.Rows[row]["salary"] = ((TextBox)GridView3.Rows[e.NewEditIndex].FindControl("txtsalary")).Text;
        Temp.AcceptChanges();
        Total = decimal.Parse(Temp.Compute("sum(Salary)", "Salary>=0").ToString());
        Session["Salary"] = Total;
        GridView3.DataSource = Temp;
        GridView3.DataBind();
    }
    protected void GridView3_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.Cells[4].Text = this.Total.ToString();
        }
    }
    protected void GridView3_RowCreated(object sender, GridViewRowEventArgs e)
    {
        //When a child checkbox is unchecked then the header checkbox will also be unchecked.
        if (e.Row.RowType == DataControlRowType.DataRow && (e.Row.RowState == DataControlRowState.Normal || e.Row.RowState == DataControlRowState.Alternate))
        {
            CheckBox chkBxSelect = (CheckBox)e.Row.Cells[1].FindControl("chkselect");
            CheckBox chkBxHeader = (CheckBox)this.GridView3.HeaderRow.FindControl("chkHeader");

            chkBxSelect.Attributes["onclick"] = string.Format("javascript:ChildClick(this,'{0}');", chkBxHeader.ClientID);
        }
    }
    #endregion   

    #region GridView4&5 (GridView inside GridView)

    #endregion

    #region GridView4 DataSource
    protected void GridView4_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        int index = e.Row.RowIndex;
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            DataTable tempdt = new DataTable();
            tempdt.Columns.Add("Id");
            tempdt.Columns.Add("Language", typeof(String));

            DataRow dr = tempdt.NewRow();
            dr["Id"] = 1;
            dr["Language"] = "C";
            tempdt.Rows.Add(dr);

            DataRow dr1 = tempdt.NewRow();
            dr1["Id"] = 2;
            dr1["Language"] = "C++";
            tempdt.Rows.Add(dr1);

            GridView gr = (GridView)(e.Row.FindControl("GridView5"));
            if (gr != null)
            {
                gr.DataSource = tempdt;
                gr.DataBind();
            }           
        }
    }
    #endregion

    #region Properties for Sorting and DataTable
    string SortField
    {
        get
        {
            object o = ViewState["SortField"];
            if (o == null)
                return String.Empty;
            else
                return (string)o;
        }
        set
        {
            ViewState["SortField"] = value;
        }
    }

    string SortDirection
    {
        get
        {
            object o = ViewState["SortDirection"];
            if (o == null)
                return String.Empty;
            else
                return (string)o;
        }
        set
        {
            ViewState["SortDirection"] = value;
        }
    }
    public DataTable Temp
    {
        get
        {
            object o = ViewState["Temp"];
            if (o == null)
            {
                DataTable dt = new DataTable();
                return dt;
            }
            else
                return (DataTable)o;
        }
        set
        {
            ViewState["Temp"] = value;
        }
    }
    #endregion

    #region GridView6 (View in PopUp and Closing it)
    protected void GridView6_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName == "view")
        {
            int row = int.Parse(e.CommandArgument.ToString());
            StringBuilder sb = new StringBuilder();
            sb.Append("<script language='javascript'>\r\n");
            sb.Append(" window.open('View.aspx?id=" + row + "', null,'width=350,height=300,scrollbars=yes,left=350,top=200,right=5,bottom=5');");
            sb.Append("</script>");
            if (!this.IsClientScriptBlockRegistered("BindScript"))
            {
                RegisterClientScriptBlock("openScript", sb.ToString());
            }
        }
    }
    #endregion

    #region Export to Word, Excel and PDF
    protected void btnword_Click(object sender, EventArgs e)
    {
        Response.AddHeader("content-disposition", "attachment;filename=FileName.doc");
        Response.Cache.SetCacheability(HttpCacheability.NoCache);
        Response.ContentType = "application/vnd.word";
        System.IO.StringWriter stringWrite = new System.IO.StringWriter();
        System.Web.UI.HtmlTextWriter htmlWrite = new HtmlTextWriter(stringWrite);

        // Create a form to contain the grid
        HtmlForm frm = new HtmlForm();
        GridView1.Parent.Controls.Add(frm);
        frm.Attributes["runat"] = "server";
        frm.Controls.Add(GridView1);
        frm.RenderControl(htmlWrite);

        //GridView1.RenderControl(htw);
        Response.Write(stringWrite.ToString());
        Response.End();
    }
    protected void btnexcel_Click(object sender, EventArgs e)
    {
        string attachment = "attachment; filename=Contacts.xls";
        Response.ClearContent();
        Response.AddHeader("content-disposition", attachment);
        Response.ContentType = "application/ms-excel";
        StringWriter sw = new StringWriter();
        HtmlTextWriter htw = new HtmlTextWriter(sw);

        // Create a form to contain the grid
        HtmlForm frm = new HtmlForm();
        GridView1.Parent.Controls.Add(frm);
        frm.Attributes["runat"] = "server";
        frm.Controls.Add(GridView1);
        frm.RenderControl(htw);

        //GridView1.RenderControl(htw);
        Response.Write(sw.ToString());
        Response.End();
    }
    protected void btnpdf_Click(object sender, EventArgs e)
    {
        Response.Clear();

        StringWriter sw = new StringWriter();
        HtmlTextWriter htw = new HtmlTextWriter(sw);
        GridView1.RenderControl(htw);

        Response.ContentType = "application/pdf";
        Response.AddHeader("content-disposition", "attachment; filename=MypdfFile.pdf");
        Response.Write(sw.ToString());
        Response.End(); 
    }
    public override void VerifyRenderingInServerForm(Control control)
    {

    }
    #endregion
}


